class RLStreamTracking
{
protected:
	int offset;
	ZWORD position;

protected:
	RLStreamTracking(const int jogged)
	{
		offset = (int) (SIDE / 2) + jogged;
		position = 0;
	}

	void skip(const ZWORD aCount)
	{
		position += aCount;
	}
};

class RLStreamDisplay : RLStreamTracking
{
private:
	void displayWord(const ZWORD word)
	{
		const int x0 = (int) (position % WIDTHINBRICKS * 12) - offset;
		const int y0 = (int) (position / WIDTHINBRICKS * 2) - offset;

		for (int y = 0; y < 2; y++)
			for (int x = 0; x < 12; x++)
				if (word & (0x10 << (x + x + y)))
					PlatformDisplayPlot(x0 + x, y0 + y);
	}

protected:
	RLStreamDisplay(const PDISPLAYPARAMS params, const int jogged) :
		 RLStreamTracking(jogged)
	{
		PlatformDisplayOpen(params);
	}

	~RLStreamDisplay()
	{
		PlatformDisplayClose();
	}

	void skip(const ZWORD aCount)
	{
		RLStreamTracking::skip(aCount);
	}

	void displayDiff(const ZWORD newWord, const ZWORD oldWord)
	{
		displayWord(newWord ^ oldWord);
	}
};
