typedef unsigned __int8 ZBYTE;
typedef unsigned __int32 ZWORD;

const ZWORD SIDE = 321048;
const ZWORD WIDTHINBRICKS = SIDE / 12;
const ZWORD HEIGHTINBRICKS = SIDE / 2;
const ZWORD TOTALCOUNT = WIDTHINBRICKS * HEIGHTINBRICKS;

typedef struct
{
	int w;
	int n;
	int e;
	int s;
	int sw;
	int nw;
	int ne;
	int se;
} BOUNDINGBOXES;

struct LIFEHEADER
{
	ZWORD size, hash, population, period;
	BOUNDINGBOXES boxes;
	int xStride, yStride;
	ZBYTE jogged, normalizer, symmetryGroup, flags;
};

struct LIFEBUFFER : LIFEHEADER
{
	ZWORD data[1];
};

const ZBYTE NORMALIZERMASK = 0x01;
const ZBYTE SYMMETRYGROUPMASK = 0x02;
const ZBYTE POPULATIONMASK = 0x04;
const ZBYTE BOUNDINGBOXMASK = 0x08;
const ZBYTE PERIODICMASK = 0x10;
const ZBYTE HASHMASK = 0x20;
